#include <stdio.h>
#define TAMANHO_MAXIMO 100

// Função para ler o valor de K
int lerValorDeK() {
    int k;
    printf("Indique K: ");
    scanf("%d", &k);
    return k;
}

// Função para validar se K está no intervalo correto
int validarIntervaloK(int k) {
    return (k >= 2 && k <= 100);
}

// Função para imprimir erro se K for inválido
void imprimirErroKInvalido() {
    printf("K tem de ser entre 2 e 100.\n");
}

// Função para ler a sequência de números inteiros positivos
int lerSequencia(int sequencia[], int tamanhoMaximo) {
    int numero, contador = 0;
    printf("Indique uma sequencia de numeros inteiros positivos, terminando com 0: ");
    while (contador < tamanhoMaximo) {
        scanf("%d", &numero);
        if (numero == 0) break;
        if (numero > 0) {
            sequencia[contador++] = numero;
        } else {
            printf("Numero invalido. Por favor, insira um inteiro positivo.\n");
        }
    }
    return contador; // Retorna o número de elementos lidos
}

// Função para calcular o produto dos elementos da sequência
int calcularProduto(int sequencia[], int tamanho) {
    int produto = 1;
    for (int i = 0; i < tamanho; i++) {
        produto *= sequencia[i];
    }
    return produto;
}

// Função para calcular a soma dos elementos da sequência
int calcularSoma(int sequencia[], int tamanho) {
    int soma = 0;
    for (int i = 0; i < tamanho; i++) {
        soma += sequencia[i];
    }
    return soma;
}

// Função para calcular o valor absoluto de um número inteiro
int valorAbsoluto(int numero) {
    if (numero < 0) {
        return -numero;
    }
    return numero;
}

// Função para calcular a soma das diferenças absolutas entre cada par de elementos
int calcularSomaDiferencasAbsolutas(int sequencia[], int tamanho) {
    int somaDiferencas = 0;
    for (int i = 0; i < tamanho - 1; i++) {
        for (int j = i + 1; j < tamanho; j++) {
            somaDiferencas += valorAbsoluto(sequencia[i] - sequencia[j]);
        }
    }
    return somaDiferencas;
}

int main() {
    int k = lerValorDeK();

    // Validar o valor de K
    if (!validarIntervaloK(k)) {
        imprimirErroKInvalido();
        return 0;
    }

    int sequencia[TAMANHO_MAXIMO];
    int tamanhoSequencia = lerSequencia(sequencia, TAMANHO_MAXIMO);

    int soma = calcularSoma(sequencia, tamanhoSequencia);
    int produto = calcularProduto(sequencia, tamanhoSequencia);

    // Verificar as regras do jogo da sequência
    if (produto <= k || soma > k) {
        printf("Sequencia invalida\n");
        return 0;
    }

    // Sequência é válida; agora verificar se é uma sequência de vitória
    int somaDiferencas = calcularSomaDiferencasAbsolutas(sequencia, tamanhoSequencia);
    if (somaDiferencas == k) {
        printf("Sequencia vitoria\n");
    } else {
        printf("Sequencia valida\n");
    }

    return 0;
}
